const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Access_rolesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const access_roles = await db.access_roles.create(
      {
        id: data.id || undefined,

        name: data.name || null,
        user_count: data.user_count || null,
        last_suspicious_login: data.last_suspicious_login || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await access_roles.setOrganizations(data.organizations || null, {
      transaction,
    });

    return access_roles;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const access_rolesData = data.map((item, index) => ({
      id: item.id || undefined,

      name: item.name || null,
      user_count: item.user_count || null,
      last_suspicious_login: item.last_suspicious_login || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const access_roles = await db.access_roles.bulkCreate(access_rolesData, {
      transaction,
    });

    // For each item created, replace relation files

    return access_roles;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const access_roles = await db.access_roles.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.name !== undefined) updatePayload.name = data.name;

    if (data.user_count !== undefined)
      updatePayload.user_count = data.user_count;

    if (data.last_suspicious_login !== undefined)
      updatePayload.last_suspicious_login = data.last_suspicious_login;

    updatePayload.updatedById = currentUser.id;

    await access_roles.update(updatePayload, { transaction });

    if (data.organizations !== undefined) {
      await access_roles.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return access_roles;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const access_roles = await db.access_roles.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of access_roles) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of access_roles) {
        await record.destroy({ transaction });
      }
    });

    return access_roles;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const access_roles = await db.access_roles.findByPk(id, options);

    await access_roles.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await access_roles.destroy({
      transaction,
    });

    return access_roles;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const access_roles = await db.access_roles.findOne(
      { where },
      { transaction },
    );

    if (!access_roles) {
      return access_roles;
    }

    const output = access_roles.get({ plain: true });

    output.organizations = await access_roles.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('access_roles', 'name', filter.name),
        };
      }

      if (filter.user_countRange) {
        const [start, end] = filter.user_countRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            user_count: {
              ...where.user_count,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            user_count: {
              ...where.user_count,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.last_suspicious_loginRange) {
        const [start, end] = filter.last_suspicious_loginRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            last_suspicious_login: {
              ...where.last_suspicious_login,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            last_suspicious_login: {
              ...where.last_suspicious_login,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.access_roles.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('access_roles', 'name', query),
        ],
      };
    }

    const records = await db.access_roles.findAll({
      attributes: ['id', 'name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.name,
    }));
  }
};
